#!/usr/bin/env python

#Runner-bar 0.2-CSS Copyright (c) 2016 JJ Posti <techtimejourney.net> 
#Runner-bar is a run/launch application.
#The program comes with ABSOLUTELY NO WARRANTY; 
#for details see: http://www.gnu.org/copyleft/gpl.html. 
#This is free software, and you are welcome to redistribute it under 
#GPL Version 2, June 1991")

#IMPORTING MODULES
import os, subprocess, sys, getpass
from gi.repository import Gtk, Gdk

class Runner(Gtk.Window):

    def about1 (self, widget):
        about1 = Gtk.AboutDialog()
        about1.set_program_name("Runner-Bar")
        about1.set_version("V.0.2-CSS")
        about1.set_copyright(" Copyright (c) 2016 JJ Posti <techtimejourney.net>")
        about1.set_comments("Runner-bar is a run/launch application.The program comes with ABSOLUTELY NO WARRANTY; for details see: http://www.gnu.org/copyleft/gpl.html. This is free software, and you are welcome to redistribute it under GPL Version 2, June 1991. ______________________________________________________________________________ Instuctions: Enter program name to start a program. https:website or http:website to open a website location. Enter a local address to open a folder or a file (for example: /home or /home/user/filename.png _______________________________________________________________________________ Available quick words are: user (opens home directory), music (opens Music directory inside user's home), desk (opens Desktop directory inside user's home), loads (opens Downloads directory inside user's home) sudo (opens graphical sudo), synaptic(opens synaptic package manager as sudo)")
        about1.set_website("www.techtimejourney.net")
        about1.run() 
        about1.destroy()
  
#Runner bar function
    def actual_going(self,widget):   
        global get_going
        get_going=self.run.get_text()
#Open Files/Folders        
        if get_going.startswith("/"):
            subprocess.Popen(['xdg-open' , get_going])
            Gtk.main_quit()            
#Open Web addresses                  
        elif get_going.startswith("https:"):
            subprocess.Popen(['xdg-open', get_going])
            Gtk.main_quit()        
        elif get_going.startswith("http:"):
            subprocess.Popen(['xdg-open', get_going ])
            Gtk.main_quit()
#Open Programs            
        else:
            subprocess.Popen([get_going])
            Gtk.main_quit()

#Go to locations (quick words)
    def uhome(self,widget):
        get_going=self.run.get_text()
#Home        
        if get_going == ("user"):
            name=getpass.getuser()
            uhome="/home/"
            combine=uhome + name 
            subprocess.Popen(['xdg-open', combine])
            Gtk.main_quit()
#Downloads            
        elif get_going == ("loads"):
            name=getpass.getuser()
            uhome="/home/"
            downloads="/Downloads"
            combine=uhome + name + downloads 
            subprocess.Popen(['xdg-open', combine])            
            Gtk.main_quit()
#Music            
        elif get_going == ("music"):
            name=getpass.getuser()
            uhome="/home/"
            music="/Music"
            combine=uhome + name + music 
            subprocess.Popen(['xdg-open', combine])
            Gtk.main_quit()
#Desktop            
        elif get_going == ("desk"):
            name=getpass.getuser()
            uhome="/home/"
            desktop="/Desktop"
            combine=uhome + name + desktop 
            subprocess.Popen(['xdg-open', combine])               								   
            Gtk.main_quit()
#Synaptic
        elif get_going == ("synaptic"):          
            subprocess.Popen(['gksudo' ,'synaptic'])               								   
            Gtk.main_quit()                        
#Run as sudo
        elif get_going == ("sudo"):          
            subprocess.Popen(['gksudo'])               								   
            Gtk.main_quit()    
####################################
#STARTING WINDOW DEFINITIONS
#################################
#GENERAL STUFF
#################################    
    def __init__(self, *args, **kwargs):
        super(Runner, self).__init__(*args, **kwargs)   
                
    # Create THE WINDOW
        self.window1=Gtk.Window()
        self.window1.set_decorated(True)
        self.window1.set_size_request(400,10)
        self.window1.move(700, 400)
        self.window1.set_keep_below(False)
        self.window1.set_position(Gtk.WindowPosition.CENTER)
        self.window1.stick()
        self.window1.set_title("Enter a command")

#Placeholder toolbar
        self.toolbar=Gtk.Toolbar()
        
#Runner bar 
        self.run=Gtk.Entry()
        self.run.connect("activate", self.actual_going)
        self.run.connect("activate", self.uhome)

#Tools and buttons
        self.about_button=Gtk.ToolButton(Gtk.STOCK_INFO)
        self.about_button.connect("clicked", self.about1)
        self.about_button.set_tooltip_text ("About")                           
        self.toolbar.insert(self.about_button, -1)
        
        self.quit_button=Gtk.ToolButton(Gtk.STOCK_STOP)
        self.quit_button.connect("clicked", Gtk.main_quit)
        self.quit_button.set_tooltip_text ("Quit")                           
        self.toolbar.insert(self.quit_button, -1)

#CSS Styles
        style_provider = Gtk.CssProvider()
        css = open('/usr/share/Runner/runner.css', 'rb')
        css_data = css.read()
        css.close()
        style_provider.load_from_data(css_data)
        Gtk.StyleContext.add_provider_for_screen(
            Gdk.Screen.get_default(),
            style_provider,
            Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)  

#Vertical container
        self.vbox=Gtk.VBox()
        self.vbox.pack_start(self.toolbar, True, True, True)
        
#Horizontal container
        self.hbox=Gtk.HBox()
        self.hbox.pack_start(self.run, True, True, True)
        self.hbox.pack_start(self.vbox, False, False, False)

#Show everything
        self.window1.add(self.hbox)		
        self.window1.show_all()
         
#More attributes        
        self.window1.set_resizable(False)
        self.window1.connect("destroy", Gtk.main_quit)
    
def main():
    Gtk.main()
    return 0

if __name__ == "__main__":
    Runner()
    main()
